using System;
using System.Collections.Generic;
using System.Linq;
using MySystem.MainModels;

namespace MySystem
{
    public class OpenRewardDetailDbconn
    {
        public readonly static OpenRewardDetailDbconn Instance = new OpenRewardDetailDbconn();

        #region 获取单个字段
        public OpenRewardDetail Get(int Id)
        {
            string key = "OpenRewardDetail:" + Id;
            if (RedisDbconn.Instance.Exists(key))
            {
                OpenRewardDetail obj = RedisDbconn.Instance.Get<OpenRewardDetail>(key);
                if (obj != null)
                {
                    return obj;
                }
            }
            WebCMSEntities db = new WebCMSEntities();
            OpenRewardDetail orderPro = db.OpenRewardDetail.FirstOrDefault(m => m.Id == Id);
            if (orderPro != null)
            {
                RedisDbconn.Instance.Set(key, orderPro);
                RedisDbconn.Instance.SetExpire(key, Library.function.get_Random(1800, 5400));
            }
            return orderPro;
        }
        #endregion


        #region 获取列表
        public List<int> GetList(int UserId, int pageNum = 1, int pageSize = 10)
        {
            string key = "OpenRewardDetail:" + UserId;
            List<int> list = new List<int>();
            if (RedisDbconn.Instance.Exists(key))
            {
                list = RedisDbconn.Instance.GetList<int>(key, pageNum, pageSize);
                if (list.Count > 0)
                {
                    return list;
                }
            }
            WebCMSEntities db = new WebCMSEntities();
            var mysqllist = db.OpenRewardDetail.Select(m => new { m.Id, m.UserId }).Where(m => m.UserId == UserId).OrderByDescending(m => m.Id).ToList();
            if (mysqllist.Count > 0)
            {
                List<int> newlist = new List<int>();
                foreach (var sub in mysqllist)
                {
                    newlist.Add(sub.Id);
                }
                RedisDbconn.Instance.Clear(key);
                foreach (int sub in newlist)
                {
                    RedisDbconn.Instance.AddRightList(key, sub);
                }
                RedisDbconn.Instance.SetExpire(key, Library.function.get_Random(1800, 5400));
            }
            db.Dispose();
            return list;
        }
        #endregion
    }
}
